/*
	ldaChainee.c
	Par Tuxgasy <tuxgasy@tuxfamily.org>
	
	This file is part of Foobar.
	
	You may redistribute it and/or modify it under the terms of the
	GNU General Public License, as published by the Free Software
	Foundation; either version 2 of the License, or (at your option) any later version.
	
	Lda is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Lda; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>

#include "ldaXML.h"
#include "ldaChainee.h"

listeArticles* initListeArticles(){
	listeArticles *teteLdaChainee;
	teteLdaChainee = NULL;
	return teteLdaChainee;
}

listeArticles* ajoutPremierArticle(int *ptrArticle, int Quantite){
	listeArticles *NouveauArticle;
	
	NouveauArticle = (listeArticles*) malloc(sizeof(listeArticles));
	if(NouveauArticle == NULL){
		return NULL;
	}
	else{
		NouveauArticle->Id = 1;
		NouveauArticle->Quantite = Quantite;
		memcpy(NouveauArticle->Article, ptrArticle, sizeof(NouveauArticle->Article));
		NouveauArticle->ptrSuivant = NULL;
		return NouveauArticle;
	}
}

enum bool ajoutArticleEnFin(listeArticles *teteLdaChainee, int *ptrArticle, int Quantite){
	listeArticles *NouveauArticle;
	listeArticles *ptrCourant;
	
	if(teteLdaChainee != NULL){
		ptrCourant = teteLdaChainee;
		while(ptrCourant->ptrSuivant != NULL){
			ptrCourant = (listeArticles *)ptrCourant->ptrSuivant;
		}
		NouveauArticle = (listeArticles*) malloc(sizeof(listeArticles));
		if(NouveauArticle == NULL){
			return FAUX;
		}
		else{
			NouveauArticle->Id = (ptrCourant->Id)+1;
			NouveauArticle->Quantite = Quantite;
			memcpy(NouveauArticle->Article, ptrArticle, sizeof(NouveauArticle->Article));
			NouveauArticle->ptrSuivant = NULL;
			ptrCourant->ptrSuivant = (struct listeArticles *)NouveauArticle;
		}
	}
	return FAUX;
}

listeArticles* ajoutNouveauArticle(listeArticles *teteLdaChainee, int *ptrArticle, int Quantite){
	if(teteLdaChainee == NULL){
		teteLdaChainee = ajoutPremierArticle(ptrArticle, Quantite);
	}
	else{
		ajoutArticleEnFin(teteLdaChainee, ptrArticle, Quantite);
	}
	return teteLdaChainee;
}

int dejaAjouter(listeArticles *teteLdaChainee, int *ptrArticle){
	listeArticles *ptrCourant;
	
	if(teteLdaChainee == NULL){
		return -1;
	}
	
	ptrCourant = teteLdaChainee;
	while((memcmp(ptrCourant->Article, ptrArticle, sizeof(ptrCourant->Article)) != 0) && (ptrCourant->ptrSuivant != NULL)){
		ptrCourant = (listeArticles *)ptrCourant->ptrSuivant;
	}
	
	if(memcmp(ptrCourant->Article, ptrArticle, sizeof(ptrCourant->Article)) == 0){
		return ptrCourant->Id;
	}
	else{
		return -1;
	}
}

void mettreAjourQuantite(listeArticles *teteLdaChainee, int Id, int QuantiteAAjouterOuAEnlever){
	listeArticles *ptrCourant;
	
	ptrCourant = teteLdaChainee;
	while(ptrCourant->Id != Id && ptrCourant->ptrSuivant != NULL){
		ptrCourant = (listeArticles *)ptrCourant->ptrSuivant;
	}
	
	ptrCourant->Quantite = (ptrCourant->Quantite)+QuantiteAAjouterOuAEnlever;
}

enum bool saveListe(listeArticles *teteLdaChainee, xmlDocPtr ptrFic, char *fichierSVG){
	listeArticles *ptrCourant;
	int prixArt, prixTotal, nbArt;
	char *ptrArticleName, *ptrArticlePrice;
	prixTotal=0;
	nbArt=0;
	FILE* ptrFichier = NULL;
	
	ptrFichier = fopen(fichierSVG, "w");
	if(ptrFichier == NULL){
		fprintf(stderr, "Impossible d'ouvrir ou de créer le fichier:\n%s\n", fichierSVG);
		return FAUX;
	}
	
	if(teteLdaChainee == NULL){
		fprintf(stderr, "Votre liste d'achat est encore vide\n");
		return FAUX;
	}
	
	ptrCourant = teteLdaChainee;
	while(ptrCourant->ptrSuivant != NULL){
		ptrArticleName = getArticleNameBySousCategory(ptrFic, ptrCourant->Article[0], ptrCourant->Article[1], ptrCourant->Article[2]);
		ptrArticlePrice = getArticlePriceBySousCategory(ptrFic, ptrCourant->Article[0], ptrCourant->Article[1], ptrCourant->Article[2]);
		prixArt = atoi(ptrArticlePrice)*(ptrCourant->Quantite);
		fprintf(ptrFichier, "%d : %s \t\t%d €\t%d\n", ptrCourant->Id, ptrArticleName, prixArt, ptrCourant->Quantite);
		ptrCourant = (listeArticles *)ptrCourant->ptrSuivant;
		
		prixTotal = prixTotal+prixArt;
		nbArt++;
	}

	ptrArticleName = getArticleNameBySousCategory(ptrFic, ptrCourant->Article[0], ptrCourant->Article[1], ptrCourant->Article[2]);
	ptrArticlePrice = getArticlePriceBySousCategory(ptrFic, ptrCourant->Article[0], ptrCourant->Article[1], ptrCourant->Article[2]);
	prixArt = atoi(ptrArticlePrice)*(ptrCourant->Quantite);
	fprintf(ptrFichier, "%d : %s \t\t%d €\t%d\n", ptrCourant->Id, ptrArticleName, prixArt, ptrCourant->Quantite);
	prixTotal = prixTotal+prixArt;
	nbArt++;
	free(ptrArticleName);
	free(ptrArticlePrice);

	fprintf(ptrFichier, "\nNombre d'article(s): %d.\n", nbArt);
	fprintf(ptrFichier, "Prix total: %d €.\n\n", prixTotal);
	
	fclose(ptrFichier);
	
	return VRAI;
}

void freeLdaChainee(listeArticles *teteLdaChainee){
	listeArticles *ptrCourant;
	listeArticles *ptrASupprimer;
	
	if(teteLdaChainee != NULL){
		ptrCourant = teteLdaChainee;
		while(ptrCourant->ptrSuivant != NULL){
			ptrASupprimer = ptrCourant;
			ptrCourant = (listeArticles *)ptrCourant->ptrSuivant;
			free(ptrASupprimer);
		}
		free(ptrCourant);
	}
}
