/*
	ldaXML.h
	Tuxgasy <tuxgasy@tuxfamily.org>
	
	This file is part of Foobar.
	
	You may redistribute it and/or modify it under the terms of the
	GNU General Public License, as published by the Free Software
	Foundation; either version 2 of the License, or (at your option) any later version.
	
	Lda is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Lda; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef DEF_LDAXML
#define DEF_LDAXML

enum bool {VRAI, FAUX};

/* Vérifier l'existance du fichier */
int is_file(const char *filename);

/*
  Initialise la lecture le fichier XML avec DOM
  Il ne faut pas oublier de libérer la mémoire avec xmlFreeDoc(xmlDocPtr ptrFic)
  */
xmlDocPtr initListe(char *fichierXML);

/*
  Parcours et affiche le contenu du fichier XML
  Cette fonction m'a servit de voir la structure du chemin XPath
  */
void show (xmlNodePtr node);

/* Retourne le nom des categories */
char *getCategoryById(xmlDocPtr ptrFic, int Id);
/* Retourne le nom des sous categories */
char *getSousCategoryByCategory(xmlDocPtr ptrFic, int IdCat, int IdSSCat);
/* Retourne le nome des articles */
char *getArticleNameBySousCategory(xmlDocPtr ptrFic, int IdCat, int IdSSCat, int IdArt);
/* Retourne le prix des articles */
char *getArticlePriceBySousCategory(xmlDocPtr ptrFic, int IdCat, int IdSSCat, int IdArt);

#endif
